import random
import time
import matplotlib.pyplot as plt
from statistics import mean

degree = 2
points = 1000

points = [i**degree for i in range(points)]
repetition = 10

resultats1 = []
resultats2 = []
for i in points:
	L = list(range(i))
	S = set(L)
	temps_calculs1 = []
	resultats1.append(temps_calculs1)
	temps_calculs2 = []
	resultats2.append(temps_calculs2)
	for _ in range(repetition):
		init_time = time.time_ns()
		-1 in L
		stop_time = time.time_ns()
		temps_calculs1.append(stop_time - init_time)
		init_time = time.time_ns()
		-1 in S
		stop_time = time.time_ns()
		temps_calculs2.append(stop_time - init_time)

plt.xlabel("Nombre d'éléments")
plt.title("Temps de vérification d'un élément qui n'est pas dans la structure")
ax1 = plt.subplot(121)
ax1.plot(
	points,
	[mean(x)/10**3 for x in  resultats1],
	marker=".",
	label="list"
	)
ax1.set_ylabel("Temps (en µs)")
ax1.set_xlabel("nb d'éléments")
plt.legend()
ax2 = plt.subplot(122)
ax2.plot(
	points,
	[mean(x)/10**3 for x in  resultats2],
	marker=".",
	label="set",
	color = 'tab:red'
	)

ax2.set_ylabel("Temps (en µs)")
ax2.set_xlabel("nb d'éléments")
ax2.yaxis.set_ticks_position("right")
ax2.yaxis.set_label_position("right")
plt.legend()
plt.savefig("set.png")
